
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "stack.h"

void stack_init(struct stack *s)
{
	s->top = NULL;
	s->n = 0;
}

void stack_push(struct stack *s, const char *value)
{
	struct item *p = malloc(sizeof(struct item));

	p->value = strdup(value);
	p->next = s->top;
	s->top = p;
	s->n++;
}

char *stack_pop(struct stack *s)
{
	struct item *p = s->top;
	char *value = p->value;

	s->top = s->top->next;
	s->n--;

	free(p);

	return value;
}

int stack_empty(struct stack *s)
{
	return s->top == NULL;
}

int stack_count(struct stack *s)
{
	return s->n;
}

